# SizeSelector

Extends \BaseExtendSelector

Selector that filters files based on their size.

It provides support for gathering the parameters together as well as for assigning an error message and throwing a build exception if an error is detected.

author | Hans Lellelid hans@xmpl.org (Phing)
author | Bruce Atherton bruce@callenish.com (Ant)
package | phing.types.selectors

### Methods

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

inherited

### Response

`\BuildException`

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

inherited

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## Return the description for the current data type.

    getDescription()

inherited

retujrn | string

## Returns any error messages that have been set.

    getError() : string

inherited

### Response

`string`

the error condition

## Allows access to the parameters gathered and set within the &lt;custom&gt; tag.

    getParameters() : array

inherited

### Response

`array`

the set of parameters defined for this selector

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Has the refid attribute of this element been set?

    isReference() : boolean

inherited

### Response

`boolean`

## The heart of the matter. This is where the selector gets to decide on the inclusion of a file in a particular fileset.

    isSelected(\PhingFile $basedir, string $filename, \PhingFile $file) : boolean

{@inheritdoc}

### Arguments

#### $basedir

`\PhingFile`

A PhingFile object for the base directory

#### $filename

`string`

The name of the file to check

#### $file

`\PhingFile`

A PhingFile object for this filename

### Response

`boolean`

whether the file should be selected or not

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

inherited

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

{@inheritdoc}

## pushAndInvokeCircularReferenceCheck

    pushAndInvokeCircularReferenceCheck(\DataType $dt,  &$stk, \Project $p)

inherited static

### Arguments

#### $dt

`\DataType`

#### $stk

``

#### $p

`\Project`

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

inherited

### Arguments

#### $desc

`string`

## Allows all selectors to indicate a setup error. Note that only the first error message is recorded.

    setError(string $msg) : void

inherited

### Arguments

#### $msg

`string`

The error message any BuildException should throw.

## Set all the Parameters for this custom selector, collected by the ExtendSelector class.

    setParameters(array $parameters) : mixed|void

inherited

### Arguments

#### $parameters

`array`

the complete set of parameters for this selector

### Response

`mixed|void`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## Sets the units to use for the comparison. This is a little complicated because common usage has created standards that play havoc with capitalization rules. Thus, some people will use "K" for indicating 1000's, when the SI standard calls for "k". Others have tried to introduce "K" as a multiple of 1024, but that falls down when you reach "M", since "m" is already defined as 0.001.

    setUnits(array $units) : void

To get around this complexity, a number of standards bodies have proposed the 2^10 standard, and at least one has adopted it. But we are still left with a populace that isn't clear on how capitalization should work.

We therefore ignore capitalization as much as possible. Completely mixed case is not possible, but all upper and lower forms are accepted for all long and short forms. Since we have no need to work with the 0.001 case, this practice works here.

This function translates all the long and short forms that a unit prefix can occur in and translates them into a single multiplier.

### Arguments

#### $units

`array`

The units to compare the size to.

## A size selector needs to know what size to base its selecting on.

    setValue(integer $size) : void

This will be further modified by the multiplier to get an actual size limit.

### Arguments

#### $size

`integer`

the size to select against expressed in units

## This specifies when the file should be selected, whether it be when the file matches a particular size, when it is smaller, or whether it is larger.

    setWhen(array $cmp) : void

### Arguments

#### $cmp

`array`

The comparison to perform, an EnumeratedAttribute

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

inherited

### Response

`\BuildException`

## toString

    toString() : string

### Response

`string`

## Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.

    validate()

inherited

throws |

## <p>Subclasses can override this method to provide checking of their state. So long as they call validate() from isSelected(), this will be called automatically (unless they override validate()).</p> <p>Implementations should check for incorrect settings and call setError() as necessary.</p>

    verifySettings()

inherited

### Constants

## SIZE_KEY

    SIZE_KEY

## UNITS_KEY

    UNITS_KEY

## WHEN_KEY

    WHEN_KEY

### Properties

## size

    size : integer

var |

### Type(s)

`integer`

## multiplier

    multiplier : integer

var |

### Type(s)

`integer`

## sizelimit

    sizelimit : integer

var |

### Type(s)

`integer`

## cmp

    cmp : integer

var |

### Type(s)

`integer`

## sizeComparisons

    sizeComparisons : array

static

var |

### Type(s)

`array`

## byteUnits

    byteUnits : array

static

var |

### Type(s)

`array`

## The passed in parameter array.

    parameters :

inherited

### Type(s)

``

## errmsg

    errmsg : string

inherited

var |

### Type(s)

`string`

## The descriptin the user has set.

    description : string

inherited

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

inherited

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`